/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.commons.utils;

import java.util.HashMap ;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: MimeTypeUtil.java,v 1.1 2004/02/29 02:33:04 dhodnett Exp $
 */
public class MimeTypeUtil {
  private static HashMap mimeTypeMapping_ ;

  static {
    mimeTypeMapping_ = new HashMap() ;
    mimeTypeMapping_.put("txt",     "text/plain") ;
    mimeTypeMapping_.put("html",    "text/html") ;
    mimeTypeMapping_.put("xml",     "text/xml") ;
    mimeTypeMapping_.put("java",    "text/plain") ;

    mimeTypeMapping_.put("jpg",     "image/jpeg") ;
    mimeTypeMapping_.put("gif",     "image/gif") ;
    mimeTypeMapping_.put("png",     "image/png") ;
    mimeTypeMapping_.put("bmp",     "image/bmp") ;

    mimeTypeMapping_.put("pdf",     "application/pdf") ;
    mimeTypeMapping_.put("bin",     "application/octet-stream") ;
  }

  static public String getMimeType(String fileName) {
    int idx = fileName.lastIndexOf(".") ;
    String ext = "bin" ;
    if (idx > 0) {
      ext = fileName.substring(idx + 1, fileName.length()) ; 
    }
    ext = ext.toLowerCase() ;
    String mimeType = (String) mimeTypeMapping_.get(ext) ;
    if (mimeType == null) mimeType = "application/octet-stream" ;
    return mimeType ;
  }
}
