/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.container.env;

import java.util.* ;
import org.exoplatform.commons.utils.ExoProperties;
import org.exoplatform.container.configuration.* ;
import org.picocontainer.Startable;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Nov 8, 2004
 * @version $Id$
 */
public class JVMEnvironment implements Startable {
  public JVMEnvironment(ConfigurationManager manager ) throws Exception {
    ServiceConfiguration sconf = manager.getServiceConfiguration(getClass()) ;
    PropertiesParam param = sconf.getPropertiesParam("add.system.properties") ;
    if(param != null) {
      ExoProperties props = param.getProperties() ;
      Iterator i = props.entrySet().iterator() ;
      while(i.hasNext()) {
        Map.Entry entry =  (Map.Entry)i.next() ;
        System.setProperty((String) entry.getKey(), (String) entry.getValue()) ;
      }
    }
    //System.out.println(getSystemPropertiesAsText());
  }
  
  public String getSystemPropertiesAsText() {
    StringBuffer b = new StringBuffer() ;
    Iterator i = System.getProperties().entrySet().iterator() ;
    while(i.hasNext()) {
      Map.Entry entry =  (Map.Entry)i.next() ;
      b.append(entry.getKey()).append("=").append(entry.getValue()).append("\n") ;
    }
    return b.toString() ;
  }
  
  public void start() {} 
  public void stop()  {}
}