/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.faces.core.component.model;

import java.util.ResourceBundle ;
import java.io.IOException;
import javax.faces.context.ResponseWriter;
import org.exoplatform.commons.utils.ExpressionUtil;
import org.exoplatform.faces.core.component.UIGrid;

/**
 * Jun 30, 2004 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: Column.java,v 1.3 2004/08/02 17:36:44 benjmestrallet Exp $
 */
public class Column {
  protected String header_;
  protected String headerClass_;
  protected String clazz_;
  String           fieldName_;

  public Column(String header, String fieldName) {
    header_ = header;
    fieldName_ = fieldName;
  }

  public String getHeader() {
    return header_;
  }

  public String getFieldName() {
    return fieldName_;
  }

  public Column setHeaderClass(String clazz, String fieldName) {
    headerClass_ = clazz;
    fieldName_ = fieldName;
    return this;
  }

  public Column setClass(String clazz) {
    clazz_ = clazz;
    return this;
  }

  public void renderHeader(ResponseWriter w, ResourceBundle res) throws IOException {
    if (headerClass_ == null) {
      w.write("<th>");  
      w.write(ExpressionUtil.getExpressionValue(res,header_)) ;
      w.write("</th>");
    } else {
      w.write("<th class='");  w.write(headerClass_);  w.write("'>") ;
      w.write(ExpressionUtil.getExpressionValue(res,header_)) ;
      w.write("</th>");
    }
  }

  public void render(ResponseWriter w, ResourceBundle res, UIGrid uiParent, String data) throws IOException {
    if (data == null) data = "";
    if (clazz_ == null) {
      w.write("<td>");    w.write(data);  w.write("</td>");
    } else {
      w.write("<td class='");   w.write(clazz_);  w.write("'>");
      w.write(data);
      w.write("</td>");
    }
  }
}