/***************************************************************************

 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *

 * Please look at license.txt in info directory for more license detail.   *

 **************************************************************************/
package org.exoplatform.faces.core.component.model;

import java.io.IOException;
import java.util.*;
import javax.faces.context.ResponseWriter;
import org.exoplatform.faces.core.component.UIGrid;

/**
 * Wed, Dec 22, 2003 @ 23:14 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: Rows.java,v 1.3 2004/08/02 17:36:45 benjmestrallet Exp $
 */
public class Rows implements HtmlFragment {
  protected List        columns;
  protected DataHandler dataHandler_;
  protected String      evenRowClass_;
  protected String      oddRowClass_;

  public Rows(DataHandler handler) {
    dataHandler_ = handler;
    columns = new ArrayList(5);
  }

  public Rows(DataHandler handler, String evenRowClass, String oddRowClass) {
    dataHandler_ = handler;
    columns = new ArrayList(5);
    evenRowClass_ = evenRowClass;
    oddRowClass_ = oddRowClass;
  }

  public Rows setEvenRowClass(String clazz) {
    evenRowClass_ = clazz;
    return this;
  }

  public Rows setOddRowClass(String clazz) {
    oddRowClass_ = clazz;
    return this;
  }

  public Rows add(Column column) {
    columns.add(column);
    return this;
  }

  public void render(ResponseWriter w, ResourceBundle res, UIGrid uiParent) throws IOException {
    dataHandler_.begin();
    if (columns != null) {
      w.write("<tr>");
      for (int i = 0; i < columns.size(); i++) {
        Column column = (Column) columns.get(i);
        column.renderHeader(w, res);
      }
      w.write("</tr>");
    }
    String clazz = evenRowClass_;
    while (dataHandler_.nextRow()) {
      if (clazz == null) {
        w.write("<tr>");
      } else {
        w.write("<tr class='");
        w.write(clazz);
        w.write("'>");
      }
      for (int i = 0; i < columns.size(); i++) {
        Column column = (Column) columns.get(i);
        String data = dataHandler_.getData(column.fieldName_);
        column.render(w, res,  uiParent, data);
      }
      w.write("</tr>");
      if (clazz == evenRowClass_) clazz = oddRowClass_;
      else clazz = evenRowClass_;
    }
  }
}