/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.faces.core.renderer.html;


import javax.faces.component.UIComponent;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import org.exoplatform.faces.FacesConstants;
import org.exoplatform.faces.core.component.UIFileUpload;
import java.io.IOException;
import java.util.ResourceBundle;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: FileUploadRenderer.java,v 1.4 2004/06/22 21:46:06 tuan08 Exp $
 */
public class FileUploadRenderer extends HtmlBasicRenderer { 
  final public void encodeBegin( FacesContext context, UIComponent component ) throws IOException {
    UIFileUpload uiFileUpload = (UIFileUpload) component;
    ExternalContext econtext = context.getExternalContext() ;
    ResourceBundle res = getApplicationResourceBundle(econtext) ;
    String uploadHeader = "Upload File" ;
    String fileLabel = "File" ;
    String nameLabel = "Name" ;
    try {
      uploadHeader = res.getString("UIFileUpload.header.upload-file-header")  ;
      fileLabel = res.getString("label.file")  ;
      nameLabel = res.getString("label.name")  ;
    } catch (Exception ex) {} 
    String baseUrl = uiFileUpload.getBaseURL(context);
    ResponseWriter w = context.getResponseWriter() ;
    w.write("<div align='center' class='" + uiFileUpload.getClazz() + "'>") ;
    w.write("<form  name='uploadForm' action='"+ baseUrl +"' method='post' enctype='multipart/form-data'>\n") ;
    w.  write("<input  type='hidden' name='"+ FacesConstants.ACTION +"' value=''/>\n") ;
    w.  write("<table border='0' cellspacing='10'>\n") ;
    w.    write("<tr>\n") ;
    w.      write("<td class='portlet-section-header' align='center' colspan='2'>\n") ;
    w.        write(uploadHeader) ;
    w.      write("</td>\n") ;
    w.    write("</tr>\n") ;
    int numOfField = uiFileUpload.getNumberOfField() ;
    for (int i = 1 ; i <= numOfField; i++) {
      w.  write("<tr>\n") ;
      w.    write("<td class='portlet-form-field-label'>\n") ;
      w.      write(fileLabel + " " + i) ;
      w.    write("</td>\n") ;
      w.    write("<td>\n") ;
      w.      write("<input style='border: 1px solid' type='file' name='file-" + i + "'/>") ;
      w.    write("</td>\n") ;
      w.  write("</tr>\n") ;
      w.  write("<tr>\n") ;
      w.    write("<td class='portlet-form-field-label'>\n") ;
      w.      write(nameLabel + " " + i) ;
      w.    write("</td>\n") ;
      w.    write("<td>\n") ;
      w.      write("<input style='border: 1px solid' name='name-" + i + "' value=''/>") ;
      w.    write("</td>\n") ;
      w.  write("</tr>\n") ;
    }
    w.    write("<tr>\n") ;
    w.      write(getScript(baseUrl)) ;
    w.      write("<td colspan='2' align='center' style='padding: 10px'>") ;
    w.        write("<input style='width: auto' type='submit' value='Upload' onclick=\"setAction('upload')\"/>") ;
    w.        write("<input style='width: auto' type='submit' value='Cancel' onclick=\"setAction('cancel')\"/>") ;
    w.      write("</td>") ;
    w.    write("</tr>\n") ;
    w.  write("</table>\n") ;
    w.write("</form>\n");
    w.write("</div>") ;    
  }

  private String getScript(String baseUrl) {
    String script = 
     "<script type=\"text/javascript\">\n" +
     "  function  setAction(action) {\n" +
     "    document.uploadForm.elements['"+FacesConstants.ACTION +"'].value =  action ;\n" +
     "  }\n" +
     "</script>\n" ;
     return script ;
  }
}