/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.  *
 **************************************************************************/
package org.exoplatform.faces.core.renderer.xhtmlmp;

import java.io.IOException;
import java.util.Enumeration ;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;

import javax.portlet.* ;
import org.exoplatform.faces.core.component.UIGrid;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.model.FormButton;
import org.exoplatform.faces.core.event.ExoActionEvent;


public  class SimpleFormRenderer 
	extends org.exoplatform.faces.core.renderer.html.SimpleFormRenderer {
  final static private String PREFIX_ACTION = ACTION + "." ;

	public void decode(FacesContext context, UIComponent component ) {
		UISimpleForm uiForm = (UISimpleForm) component ; 
		PortletRequest request = (PortletRequest)context.getExternalContext().getRequest() ;
		Enumeration names = request.getParameterNames()  ;
		while (names.hasMoreElements()) {
			String name = (String) names.nextElement(); 
			System.out.println(name);
			if (name.startsWith(PREFIX_ACTION)) {
				String userAction = name.substring(PREFIX_ACTION.length(), name.length()) ;
				System.out.println(userAction);
				uiForm.setUserAction(userAction) ;
				uiForm.broadcast(new ExoActionEvent(uiForm, userAction, request.getParameterMap())) ;
				return;
			}
		}
	}
	
	public void renderFormButton(FormButton button, ResponseWriter w, UIGrid uiParent)  throws IOException {
	  w.write("<input type='submit'");
	  String clazz = button.getClazz() ;
	  if (clazz != null) {
	    w.write(" class='"); w.write(clazz);  w.write("'");
	  }
	  w.write(" name='"); w.write(PREFIX_ACTION);  w.write(button.getAction());  w.write("'"); 
	  w.write(" value='"); w.write(getLabel(button.getLabel())); w.write("'/>");
	}
  
  protected String getScript(UISimpleForm uiForm) {
    return "" ;
  }
  
  public String getLabel(String label) {
   if(label.indexOf("<img") >= 0) {
     String[] temp = label.split("<img.*>") ;
     label = "" ;
     for(int i = 0 ; i < temp.length; i++) {
       label  += temp[i];
     }
   }
   return label ; 
 }
}