package org.exoplatform.maven.plugin;

import java.util.* ;
import java.io.* ;
import org.apache.commons.jelly.*;
import org.apache.maven.jelly.MavenJellyContext ;

public class AppXMLDescriptor extends TagSupport {
  private String earDir ;
  
  public AppXMLDescriptor() {  }

  public void doTag(XMLOutput arg0) throws JellyTagException {
    System.out.println("generate application.xml file") ;
    //MavenJellyContext jcontext = (MavenJellyContext)getContext() ;
    //System.out.println("property: maven.exoplatform.dir " + jcontext.getVariable("maven.exoplatform.dir")) ;
    try {
      File dir = new File(earDir) ;
      StringBuffer b = new StringBuffer() ;
      b.append("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
      b.append("<!DOCTYPE application PUBLIC \"-//Sun Microsystems, Inc.//DTD J2EE Application 1.3//EN\" \"http://java.sun.com/dtd/application_1_3.dtd\">") ;
      b.append("<application>\n") ;
      b.append("  <display-name>exoplatform</display-name>\n") ;
      String[]  file = dir.list() ;
      //sort to display all war file on top
      for(int i = 0 ; i < file.length; i++ ) {
        if(!file[i].endsWith("war"))  continue ;
        int idx = file[i].indexOf('.') ;
        String context = file[i].substring(0, idx) ;
        b.append("  <module>\n") ;
        b.append("    <web>\n") ;
        b.append("      <web-uri>").append(file[i]).append("</web-uri>\n") ;
        b.append("      <context-root>").append(context).append("</context-root>\n") ;
        b.append("    </web>\n") ;
        b.append("  </module>\n") ;
      }
      /*for(int i = 0 ; i < file.length; i++ ) {
        if(!file[i].endsWith("jar")) continue ;
        b.append("  <module>\n") ;
        b.append("    <java>").append(file[i]).append("</java>\n") ;
        b.append("  </module>\n") ;
      }*/
      b.append("</application>\n") ;

      File application = new File(earDir + "/META-INF/application.xml") ;
      FileOutputStream out = new FileOutputStream(application) ;
      out.write(b.toString().getBytes()) ;
      out.close() ;
    } catch (Exception ex) {
      ex.printStackTrace() ;
    }
  }

  public String getEarDir() { return this.earDir ; }
  public void   setEarDir(String s) { this.earDir = s ; }
}
