/*
 * Jul 8, 2004, 3:39:40 PM
 * @author: F. MORON
 * @email: francois.moron@rd.francetelecom.com
 * 
 * */
package org.exoplatform.portal;

public class ClientInfo {
	private String name_;
	private String userAgentPattern_;
	private String preferredMimeType_;
	private String renderer_ = "default";
	
	public ClientInfo(String name, String userAgentPattern, String preferredMimeType, String renderer) {
		this(name, userAgentPattern, preferredMimeType);
		renderer_ = renderer;
	}

	public ClientInfo(String name, String userAgentPattern, String preferredMimeType) {
		name_ = name;
		userAgentPattern_ = userAgentPattern;
		preferredMimeType_ = preferredMimeType;
	}
	
	public ClientInfo() {
		this("", "", "");
	}

	/**
	 * @return Returns the name_.
	 */
	public String getName() {
		return name_;
	}
  
	/**
	 * @return Returns the preferredMimeType_.
	 */
	public String getPreferredMimeType() {
		return preferredMimeType_;
	}
  
	/**
	 * @return Returns the userAgentPattern_.
	 */
	public String getUserAgentPattern() {
		return userAgentPattern_;
	}

	/**
	 * @return Returns the renderer_.
	 */
	public String getRenderer() {
		return renderer_;
	}
}
