/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portal;

import javax.servlet.http.HttpServletRequest;
import org.exoplatform.portal.Constants;
/**
 * Apr 12, 2004
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: PortalRequestParameters.java,v 1.6 2004/09/27 03:01:18 tuan08 Exp $
 **/
public class PortalRequestParameters {
  private String portalOwner_ ;
  private String pageName_ ;
  private String portalAction_ ;
  private String targetComponentId_ ;
  private String portletWindowState_ ;
  private String portletMode_ ;
  private String portletActionType_ ;
  private String lang_ ;
  
  public PortalRequestParameters(HttpServletRequest req) {
    //parse uri ;
    String pathInfo = req.getPathInfo() ;
    int slashIndex =  pathInfo.indexOf('/', 1) ;
    if(slashIndex > 0) {
      portalOwner_ = pathInfo.substring(1, slashIndex) ;
      pageName_ =  pathInfo.substring(slashIndex , pathInfo.length()) ;
    } else {
      portalOwner_ = pathInfo.substring(1, pathInfo.length()) ;
      pageName_ = null ;
    }
    portalAction_ = req.getParameter(Constants.PORTAL_ACTION) ;
    targetComponentId_ = req.getParameter(Constants.COMPONENT_PARAMETER) ;
    portletWindowState_ = req.getParameter(Constants.WINDOW_STATE_PARAMETER) ;
    portletMode_ = req.getParameter(Constants.PORTLET_MODE_PARAMETER) ;
    portletActionType_ = req.getParameter(Constants.TYPE_PARAMETER);
    lang_ = req.getParameter(Constants.LANGUAGE_PARAMETER) ;
  }
  
  public PortalRequestParameters(String contextPath, String user, HttpServletRequest req) {
    portalOwner_ = user ;
    pageName_ = null ;
    portalAction_ = req.getParameter(Constants.PORTAL_ACTION) ;
    targetComponentId_ = req.getParameter(Constants.COMPONENT_PARAMETER) ;
    portletWindowState_ = req.getParameter(Constants.WINDOW_STATE_PARAMETER) ;
    portletMode_ = req.getParameter(Constants.PORTLET_MODE_PARAMETER) ;
    portletActionType_ = req.getParameter(Constants.TYPE_PARAMETER);
    lang_ = req.getParameter(Constants.LANGUAGE_PARAMETER) ;
  }
  
  public PortalRequestParameters() {
    portalOwner_ = "exotest" ;
    pageName_ = "/" ;
  }
  
  public String getPortalOwner() { return portalOwner_ ; }
  public String getPageName() { return pageName_ ; }
  
  public String getPortalAction() { return portalAction_ ; }
  public String getTargetComponentId() { return targetComponentId_ ; }
  public String getPortletWindowState() { return portletWindowState_ ; }
  public String getPortletMode() { return portletMode_ ; }
  public String getPortletActionType() { return portletActionType_ ; }
  public String getLanguage() { return lang_ ; }
}