/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portal.faces.renderer.html.portal;

import java.io.IOException;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.exoplatform.portal.ExoPortalInfo;
import org.exoplatform.portal.faces.component.UIPortal;
import org.exoplatform.portal.faces.renderer.BaseRenderer;
/**
 * Date: Aug 11, 2003
 * @author : Mestrallet Benjamin
 * @email:   benjmestrallet@users.sourceforge.net
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: PortalRenderer.java,v 1.11 2004/10/08 18:03:13 benjmestrallet Exp $
 */
public class PortalRenderer extends BaseRenderer {
  private static String EN_KEYWORD = "portlet, portal, jsr-168, jboss, JSF" ;

  public PortalRenderer() {
  }
  
  public void encodeChildren(FacesContext context, UIComponent uiComponent) throws IOException {
    ExoPortalInfo epinfo = ExoPortalInfo.getCurrentInstance() ;
    HttpServletRequest request = (HttpServletRequest) context.getExternalContext().getRequest();
    HttpServletResponse response = (HttpServletResponse) context.getExternalContext().getResponse();
    UIPortal uiPortal = (UIPortal) uiComponent ;
    epinfo.getLocaleConfig().setOutput(response) ;
    ResponseWriter w = context.getResponseWriter();
    w.write("\n<!DOCTYPE html\n"); 
    w.write("     PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\"\n");
    w.write("     \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n");     
    w.write("<html xmlns=\"http://www.w3.org/1999/xhtml\"> \n");
    w.  write("<head>\n");
    w.    write("<base href='http://" + request.getServerName() + ":" + request.getServerPort() + "'/>") ;
    w.    write("<meta name='keywords' lang='en' content='" + EN_KEYWORD + "' />\n") ;
    w.    write("<link rel='stylesheet' type='text/css' href='") ;
          w.write(epinfo.getContextPath()) ;
          w.write("/default-skin.css' />\n"); 
    w.    write(uiPortal.getUserCss());
    w.  write("</head>\n");
    w.  write("<body>\n") ;
    renderChildren(context, uiPortal) ; 
    w.  write("</body>\n") ;
    w.write("</html>\n") ;
  }
}