/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

/**
 * Created by The eXo Platform SARL        .
 * Date: Jan 25, 2003
 * Time: 5:25:52 PM
 */
package org.exoplatform.portal.launcher;


import javax.faces.FactoryFinder;
import javax.faces.event.PhaseEvent;
import javax.faces.event.PhaseId;
import javax.faces.event.PhaseListener;
import javax.faces.lifecycle.Lifecycle;
import javax.faces.lifecycle.LifecycleFactory;
import javax.servlet.ServletContext;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;
import org.exoplatform.container.PortalContainer;
import org.exoplatform.container.RootContainer;
import org.exoplatform.portal.ExoPortalInfo;
import org.exoplatform.portal.PortalRequestParameters;
import org.exoplatform.services.portal.model.Node;
import org.exoplatform.services.resources.ResourceBundleService;

public class PortalContextListener implements ServletContextListener {
  
	protected ServletContext portalServletContext_ = null;

	public void contextInitialized(ServletContextEvent event) {
		portalServletContext_ = event.getServletContext();
    RootContainer rootContainer = RootContainer.getInstance();    
    PortalContainer portalContainer = 
      rootContainer.createPortalContainer(portalServletContext_);
    PortalContainer.setInstance(portalContainer) ;
    LifecycleFactory lfactory = 
      (LifecycleFactory) FactoryFinder.getFactory( FactoryFinder.LIFECYCLE_FACTORY );
    Lifecycle lifecycle = lfactory.getLifecycle( LifecycleFactory.DEFAULT_LIFECYCLE );
    lifecycle.addPhaseListener(new RestoreViewListener()) ;
    ResourceBundleService rservice =
    ((ResourceBundleService)portalContainer.getComponentInstanceOfType(ResourceBundleService.class)) ;
    rservice.getResourceBundle("locale.custom.custom") ;  
    rservice.getResourceBundle("locale.users.default") ;
    PortalContainer.setInstance(null) ;
  }

	public void contextDestroyed(ServletContextEvent event) {
    RootContainer rootContainer = RootContainer.getInstance();
    PortalContainer pcontainer = 
      rootContainer.getPortalContainer(event.getServletContext().getServletContextName());
    if(pcontainer.isStarted())pcontainer.stop() ;
    rootContainer.removePortalContainer(event.getServletContext()) ;
  }
  
  
  public static class RestoreViewListener implements PhaseListener {
    public void afterPhase(PhaseEvent event) {
      ExoPortalInfo pinfo = ExoPortalInfo.getCurrentInstance();
      if(pinfo.isNew()) return ;
      PortalRequestParameters pparams = pinfo.getPortalRequestParameters();
      String nodeURI = pparams.getPageName() ;
      if(nodeURI != null && ! pinfo.getSelectedNode().getUri().equals(nodeURI)) {
        Node node = pinfo.getRootNode().findNode(nodeURI) ;
        if(node != null) {
          try {
            pinfo.setSelectedNode(node) ;
          } catch (Exception ex) {
            ex.printStackTrace() ;
          }
        }
        event.getFacesContext().renderResponse()  ;
      }
    }
    
    public void beforePhase(PhaseEvent event) {
      
    }
    
    public PhaseId getPhaseId() {   return PhaseId.RESTORE_VIEW ;   }
  }
}