/**
 **************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.portlet.cocoon;


import javax.portlet.*;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequestWrapper;
import org.exoplatform.portlet.commons.servlet.BufferedServletResponse;
import org.exoplatform.services.portletcontainer.ExoPortletContext;
import org.exoplatform.services.portletcontainer.impl.portletAPIImp.*;
import org.exoplatform.services.portletcontainer.impl.portletAPIImp.helpers.CustomRequestWrapper;
import java.io.IOException;
import java.io.Writer;

//import javax.servlet.ServletOutputStream;

/**
 * Created by The eXo Platform SARL        .
 *
 * @author Gennady Azarenkov
 * @version $Id: CocoonPortlet.java,v 1.8 2004/07/08 23:39:27 benjmestrallet Exp $
 */

public class CocoonPortlet extends GenericPortlet {
  private String servletName;

  public void init(PortletConfig config) throws PortletException {
    super.init(config);
    servletName = config.getInitParameter("servlet-name");
    if (servletName == null)
      servletName = config.getPortletName();
  }

  public void render(RenderRequest request, RenderResponse response) throws PortletException, java.io.IOException {
    doView(request, response);
  }

  public void doView(RenderRequest request, RenderResponse response) throws PortletException, IOException {
    WindowState state = request.getWindowState();
    String path = "/";
    //    System.out.println("---->>>>>>>Cocoon Portlet in View Mode!");
    CustomRequestWrapper requestWrapper = null;
    ExoPortletContext context = (ExoPortletContext) request.getPortletSession().getPortletContext();
    boolean isSharedSessionEnable = context.isSessionShared();
    try {
      requestWrapper = ((CustomRequestWrapper) ((HttpServletRequestWrapper) request).getRequest());
      BufferedServletResponse responseWrapper = new BufferedServletResponse((RenderResponseImp) response);
      PortletContextImpl portletContext = (PortletContextImpl) getPortletContext();
      ServletContext scontext = portletContext.getWrappedServletContext();
      RequestDispatcher dispatcher = null;
      String requestUrl = requestWrapper.getParameter("url");
      System.out.println("Portlet RequestURI: " + requestUrl);
      dispatcher = scontext.getNamedDispatcher(servletName);
      if (requestUrl != null)
        path += requestUrl;
      // System.out.println("Real Path: " + scontext.getRealPath(path));
      responseWrapper.flushBuffer();
      requestWrapper.setRedirected(true);
      requestWrapper.setRedirectedPath(path);
      if (isSharedSessionEnable) {
        PortletSessionImp pS = (PortletSessionImp) request.getPortletSession();
        requestWrapper.setSharedSession(pS.getSession());
        requestWrapper.setContextPath(request.getContextPath());
      }
      dispatcher.include(requestWrapper, responseWrapper);
      response.setContentType("text/html");
      Writer writer = response.getWriter();
      byte[] buffer = responseWrapper.toByteArray();
      writer.write(URLRewriter.rewrite(buffer,
          getLinkPrefix(requestWrapper.getServletPath(),
              requestWrapper.getPathInfo()),
          response.createRenderURL().toString()));   
    } catch (Exception e) {
      e.printStackTrace();
      throw new PortletException("Problems occur when using PortletDispatcher", e);
    } finally {
      if (requestWrapper != null)
        requestWrapper.setRedirected(false);
      if (isSharedSessionEnable) {
        requestWrapper.setSharedSession(null);
      }
    }
  }

  /* G.A. Do not sure how generic is it */

  private String getLinkPrefix(String servPath, String pathInfo) {
    if (servPath == null || servPath == "/")
      servPath = "";
    if (pathInfo == null || pathInfo == "/")
      pathInfo = "";
    String prefix = servPath + pathInfo;
    if (prefix.length() == 1)
      prefix = "";
    if (prefix.startsWith("/"))
      prefix = prefix.substring(1);
    return prefix;
  }
}
