/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.portlet.cocoon;


import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;
import org.exoplatform.container.PortalContainer;
import org.exoplatform.services.xml.transform.Transformer;
import org.exoplatform.services.xml.transform.TransformingService;
import org.exoplatform.services.xml.transform.pipe.PipeTransformer;
import org.exoplatform.services.xml.transform.trax.Constants;
import org.exoplatform.services.xml.transform.trax.TraxTransformer;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.io.IOException;

/**
 * Created by The eXo Platform SARL        .
 * <p/>
 * Url rewriter for XHTML script
 * href="original-url" will be rewrited as
 * href="<portlet-url>?<href-param>=<original-url>"
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: URLRewriter.java,v 1.5 2004/07/24 16:43:47 tuan08 Exp $
 */

public class URLRewriter {

  public static final String PREFIX_URL = "portlet-url";
  public static final String HREF_PARAM = "href-param";
  public static final String HREF_CONTEXT = "href-context";
  public static final String HTML_URL_REWRITE_STYLE = Constants.XSLT_DIR + "/html-url-rewite.xsl";

  public static String rewrite(byte[] buffer, String linkPrefix, String urlPrefix) throws TransformerException,
      TransformerConfigurationException, InstantiationException, IOException {

//    System.out.println("Content to transform : " + new String(buffer));

    TransformingService service = (TransformingService) PortalContainer.getInstance().
        getComponentInstanceOfType(TransformingService.class);

    PipeTransformer transformer = (PipeTransformer) service.
            getTransformer(org.exoplatform.services.xml.transform.impl.pipe.PipeTransformerImpl.class);

    Transformer tider = service.getTransformer(org.exoplatform.services.xml.transform.impl.html.TidyTransformer.class);

    TraxTransformer rewriter = (TraxTransformer) service.
        getTransformer(org.exoplatform.services.xml.transform.impl.trax.TraxTransformerWrapper.class);
    InputStream iS = Thread.currentThread().getContextClassLoader().getResource(HTML_URL_REWRITE_STYLE).openStream();
    byte buf[] = new byte[iS.available()];
//    System.out.println("Size : " + iS.available());
    for(int start = 0; start < buf.length; start += iS.read(buf, start, buf.length - start));
//    System.out.println("Very first content : " + new String(buf));
    rewriter.initStyle(new StreamSource(new ByteArrayInputStream(buf)));
    rewriter.setParameter(HREF_CONTEXT, linkPrefix);
    rewriter.setParameter(PREFIX_URL, urlPrefix);
    rewriter.setParameter(HREF_PARAM, "url");

    transformer.addTransformRule(tider).addTransformRule(rewriter);
    StreamResult result = new StreamResult(new ByteArrayOutputStream());
    transformer.transform(new StreamSource(new ByteArrayInputStream(buffer)), result);

    return result.getOutputStream().toString();
  }
}
