/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.console.renderer.html;

import java.util.List ;
import java.util.ResourceBundle ;
import java.io.IOException;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import org.exoplatform.faces.core.component.UINode ;
import org.exoplatform.faces.core.component.UIExoComponent ;
import org.exoplatform.faces.core.component.model.Parameter ;
import org.exoplatform.faces.core.renderer.html.HtmlBasicRenderer;
import org.exoplatform.portlets.console.component.UIAdminConsolePortlet;
/**
 * Jul 29, 2004 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id$
 */
public class AdminConsolePortletRenderer extends HtmlBasicRenderer {
	public void encodeChildren( FacesContext context, UIComponent component ) throws IOException {
    UIAdminConsolePortlet uiPortlet = (UIAdminConsolePortlet) component ;
    ResourceBundle res = getApplicationResourceBundle(context.getExternalContext()) ;
    ResponseWriter w = context.getResponseWriter() ;
    Parameter componentIdParam = new Parameter(UIAdminConsolePortlet.COMPONENT_ID,"") ;
    Parameter[] params = {UIAdminConsolePortlet.CHANGE_COMPONENT, componentIdParam} ;
    w.write("<table class='UIAdminConsolePortlet'>") ;
    w. write("<tr>");
    w.  write("<td class='header' colspan='2'>") ;
    w.    write(res.getString("UIAdminConsolePortlet.header.title"));
    w.  write("</td>");
    w. write("</tr>");
    w. write("<tr>");
    w.  write("<td class='navigation'>") ;
    renderNavigation(w, uiPortlet, res, params) ;
    w.  write("</td>") ;
    w.  write("<td class='component'>") ;
    renderChildren(context, uiPortlet) ;
    w.  write("</td>") ;
    w. write("</tr>");
    w. write("<tr>");
    w.  write("<td class='footer' colspan='2'>") ;    
    w.  write("</td>");
    w. write("</tr>");
    w.write("</table>") ; 
	}	
  
  private void renderNavigation(ResponseWriter w, UIAdminConsolePortlet uiPortlet,
                                ResourceBundle res, Parameter[] params ) throws IOException  {
    List children = uiPortlet.getChildren() ;
    w.write("<ul>") ;
    for(int i = 0; i < children.size() ; i++) {
      Object obj =  children.get(i) ;
      if(obj instanceof UINode) {
        UINode uiNode = (UINode) obj ;
        renderNode(w, uiPortlet, uiNode, res, params) ;
      } else {
        UIExoComponent uiComponent = (UIExoComponent) obj ;
        renderComponent(w, uiPortlet, uiComponent, res, params) ;
      }
    }
    w.write("</ul>") ;
  }
  
  
  private void renderNode(ResponseWriter w, UIAdminConsolePortlet uiPortlet, 
                          UINode uiNode, ResourceBundle res, Parameter[] params ) throws IOException  {
    w.write("<ul>") ;
    params[1].setValue(uiNode.getId()) ;
    linkRenderer_.render(w, uiPortlet, res.getString(uiNode.getName()), params) ;
    if(uiNode.isRendered())  {
      List children = uiNode.getChildren() ;
      for(int i = 0; i < children.size() ; i++) {
        UIExoComponent uiComponent = (UIExoComponent) children.get(i) ;
        renderComponent(w, uiPortlet, uiComponent, res, params) ;
      }
    }
    w.write("</ul>") ;
  }
  
  private void renderComponent(ResponseWriter w, UIAdminConsolePortlet uiPortlet, 
                               UIExoComponent uiComponent, ResourceBundle res, Parameter[] params) throws IOException  {
    w.write("<li>") ;
    params[1].setValue(uiComponent.getId()) ;
    linkRenderer_.render(w, uiPortlet, res.getString("UINode.label." + uiComponent.getId()), params) ;
    w.write("</li>") ;
  }
}
