/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.monitor.component;

import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.component.model.*;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.portal.log.Query;
/**
 * Sat, Jan 03, 2004 @ 11:16 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UISearchUserForm.java,v 1.6 2004/10/22 14:23:30 tuan08 Exp $
 */
public class UISearchLogForm extends UISimpleForm {

  public static final String SEARCH_LOG = "search";

  private UIStringInput remoteUser_ ;
  private UIStringInput ipAddress_ ;

  public UISearchLogForm() {
    super("searchForm", "post", null) ;
    setId("UISearchLogForm");
    remoteUser_ = new UIStringInput("remoteUser", "") ;
    ipAddress_ = new UIStringInput("ipAddress", "") ;
    add(new Row().
        add(new LabelCell("#{UISearchLogForm.label.remote-user}")).
        add(new ComponentCell(this, remoteUser_))) ;
    add(new Row().
        add(new LabelCell("#{UISearchLogForm.label.ip-address}")).
        add(new ComponentCell(this, ipAddress_))) ;
    add(new Row().
        add(new ListComponentCell().
            add(new FormButton("#{UISearchLogForm.button.search}", SEARCH_LOG)).            
            addColspan("2").addAlign("center"))) ;
   
    addActionListener(SearchUserActionListener.class, SEARCH_LOG) ;  
  }

  static public class SearchUserActionListener extends ExoActionListener  {
    public void execute(ExoActionEvent event) throws Exception {
      UISearchLogForm uiForm = (UISearchLogForm) event.getComponent() ;
      UIListSessionLog uiList = (UIListSessionLog) uiForm.getParent() ;
      Query q = new Query() ;
      q.setRemoteUser(uiForm.remoteUser_.getValue()) ;
      q.setIPAddress(uiForm.ipAddress_.getValue()) ;
      uiList.update(q) ;
    }
  }
}