/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.communication.forum.component;

import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.component.UITextArea;
import org.exoplatform.faces.core.component.model.*;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.communication.forum.Category;
import org.exoplatform.services.communication.forum.ForumService;

/**
 * Sat, Jan 03, 2004 @ 11:16 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UICategoryForm.java,v 1.7 2004/10/17 13:46:25 tuan08 Exp $
 */
public class UICategoryForm extends UISimpleForm {
  private ForumService service_ ;
  private UIStringInput categoryName_ ;
  private UITextArea    description_ ;
  private Category category_ ;
  
  public UICategoryForm(ForumService service) throws Exception {
    super("categoryForm", "post", null) ;
    setId("UICategoryForm") ;
    setClazz("UICategoryForm") ;
    service_ = service ;
    description_ = new UITextArea("description", "") ;
    categoryName_ = new UIStringInput("categoryName", "") ;
    add(new HeaderRow().
        add(new Cell("#{UICategoryForm.header.title}").
            addColspan("2")));
    add(new Row().
        add(new LabelCell("#{UICategoryForm.label.name}")).
        add(new ComponentCell(this, categoryName_)));
    add(new Row().
        add(new LabelCell("#{UICategoryForm.label.description}").
            addValign("top")).
        add(new ComponentCell(this, description_)));
    add(new Row().
        add(new ListComponentCell().
            add(new FormButton("#{UICategoryForm.button.save}", SAVE_ACTION)).
            add(new FormButton("#{UICategoryForm.button.cancel}", CANCEL_ACTION)).
            addColspan("2").addAlign("center"))) ;
    addActionListener(CancelActionListener.class, CANCEL_ACTION)  ;
    addActionListener(SaveActionListener.class, SAVE_ACTION)  ;
  }
  
  public void setCategory(Category category) {
    category_ = category ;
    if (category == null) {
      categoryName_.setText("") ;
      description_.setText("") ;
    } else {
      categoryName_.setText(category.getCategoryName()) ;
      description_.setText(category.getDescription()) ;
    }
  }
  
  static public class CancelActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
			UICategoryForm uiForm = (UICategoryForm) event.getComponent() ;
			uiForm.setRenderedSibling(UIAdminViewCategories.class) ;
		}
  }
  
  static public class SaveActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
			UICategoryForm uiForm = (UICategoryForm) event.getComponent() ;
      String desc = uiForm.description_.getText() ;
      String name = uiForm.categoryName_.getText() ;
      Category category = uiForm.category_ ;
       boolean isNew =  false ;
       if(category == null) {
         category = uiForm.service_.createCategoryInstance() ;
         isNew = true ;
       }
       category.setCategoryName(name) ;
       category.setDescription(desc) ;
       if(isNew) {
         uiForm.service_.addCategory(category) ;
       } else {
         uiForm.service_.updateCategory(category) ;
       }
       UIAdminViewCategories uiCategories =
       	(UIAdminViewCategories) uiForm.getSibling(UIAdminViewCategories.class) ;
       uiCategories.update() ;
			 uiForm.setRenderedSibling(UIAdminViewCategories.class) ;
		}
  }
}