/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.explorer.component;

import org.exoplatform.faces.core.component.UIHtmlTextArea;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.component.model.*;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIContentEditor.java,v 1.1 2004/07/16 09:51:34 oranheim Exp $
 */
public class UIContentEditor extends UISimpleForm {
	final static public String PREVIEW_CONTENT_ACTION = "preview" ;
	final static public String EDIT_CURRENT_CONTENT_ACTION = "editCurrent" ;
	final static public String SAVE_CONTENT_ACTION = "saveContent" ;
	final static public String CANCEL_ACTION = "cancel" ;
	
	final static public String CONTENT_PREVIEW_RENDERER = "ContentPreviewRenderer" ;
	final static public String CONTENT_FORM_RENDERER = "SimpleFormRenderer" ;

  protected String parentUri_ ;
  protected String mimeType_ ;

  protected UIStringInput localName_ ;
  protected UIHtmlTextArea content_ ;

  public UIContentEditor() {
    super("contentForm", "post", null) ;
    setId("UIContentEditor") ;
    setClazz("UIContentEditor") ;

    content_ = new UIHtmlTextArea("content", "", "100%", "550px") ;
    localName_ = new UIStringInput("localName", "") ;
    add(new Row().
        add(new ComponentCell(this, content_).
            addColspan("2").addClazz("html-text-area")));
    add(new Row().
        add(new Cell("#{UIContentEditor.label.save-as}")).
        add(new ComponentCell(this, localName_)));
    add(new Row().
        add(new ListComponentCell().
            add(new FormButton("#{UIContentEditor.button.save}", SAVE_CONTENT_ACTION)).
            add(new FormButton("#{UIContentEditor.button.preview}", PREVIEW_CONTENT_ACTION )).
            add(new FormButton("#{UIContentEditor.button.cancel}", CANCEL_ACTION)).
            addColspan("2").addAlign("center"))) ;       
  }

  public String getContent() { return content_.getValue() ; }
  public String getMimeType() { return mimeType_ ; }
  public String getParentUri() { return parentUri_ ;}
  public String getLocalName() { return localName_.getValue() ;}
 

  public void populateEdit(String parentUri, String localName,String mime, String content) {
    parentUri_ = parentUri ;
    localName_.setValue(localName)  ;
    content_.setValue(content) ;
    mimeType_ = mime ;
    setRendererType(CONTENT_FORM_RENDERER) ;
  }

  public void populatePreview(String parentUri, String localName, String content) {
    parentUri_ = parentUri ;
    localName_.setValue(content) ;
    content_.setValue(content) ;
    setRendererType(CONTENT_PREVIEW_RENDERER) ;
  }
  
  static public class PreviewContentActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
      UIContentEditor uiEditor = (UIContentEditor) event.getComponent() ;
			uiEditor.setRendererType(CONTENT_PREVIEW_RENDERER) ;
		}
	}
  
  static public class EditCurrentActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
      UIContentEditor uiEditor = (UIContentEditor) event.getComponent() ;
			uiEditor.setRendererType(CONTENT_FORM_RENDERER) ;
		}
	}

}