/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.explorer.component;

import java.io.FileOutputStream;
import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.core.component.InformationProvider;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;

/**
 * Jun 22, 2004 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIFileContentEditor.java,v 1.3 2004/08/17 13:07:02 tuan08 Exp $
 */
public class UIFileContentEditor extends UIContentEditor {
	public UIFileContentEditor() {
		addActionListener(ShowExplorerActionListener.class, CANCEL_ACTION)  ;
		addActionListener(PreviewContentActionListener.class, PREVIEW_CONTENT_ACTION)  ;
		addActionListener(EditCurrentActionListener.class, EDIT_CURRENT_CONTENT_ACTION)  ;
		addActionListener(SaveContentActionListener.class, SAVE_CONTENT_ACTION)  ;
	}
	
	static public class SaveContentActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
			UIFileContentEditor uiEditor = (UIFileContentEditor) event.getComponent() ;
			UIFilePortlet uiController = (UIFilePortlet) uiEditor.getParent() ;
			InformationProvider iprovider = findInformationProvider(uiEditor) ;
			String localName = uiEditor.localName_.getValue() ;
		  String content =  uiEditor.content_.getValue() ; 
		  String parentUri = uiEditor.getParentUri() ;
		  if (localName == null || localName.length() == 0) {
		    iprovider.addMessage(new ExoFacesMessage("#{UIFileContentEditor.msg.file-name-is-empty}")) ;
		  } else {
		  	String uri = parentUri + "/" + localName ;
		    String path = uiController.getBaseDir() + uri  ;
		    FileOutputStream os= new FileOutputStream(path) ;
		    os.write(content.getBytes()) ;
		    os.close() ;
		    UIFileExplorer uiExplorer = 
		    	(UIFileExplorer) uiController.getChildComponentOfType(UIFileExplorer.class) ;
		    uiExplorer.updateCache(uri) ;
		    iprovider.addMessage(new ExoFacesMessage("#{UIFileContentEditor.msg.save-file-success}")) ;
		  }
		}
	}
}