/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.explorer.renderer.html;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import org.exoplatform.commons.utils.HtmlUtil;
import org.exoplatform.faces.FacesConstants;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.renderer.html.HtmlBasicRenderer;
import org.exoplatform.portlets.content.explorer.component.UIContentDisplayer;
import java.io.IOException;

/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: TextContentRenderer.java,v 1.1 2004/07/16 09:51:34 oranheim Exp $
 */
public class TextContentRenderer extends HtmlBasicRenderer { 
	 private static Parameter[] backParams = 
	 	 { new Parameter(FacesConstants.ACTION , UIContentDisplayer.BACK_ACTION)} ;

  final public void encodeBegin( FacesContext context, UIComponent component ) throws IOException {
    UIContentDisplayer uiDisplayer = (UIContentDisplayer) component;
    String content = uiDisplayer.getContent() ;
    String mime = uiDisplayer.getMimeType() ;
    if ("text/plain".equals(mime)) content = "<pre>" + content + "</pre>" ;
    else if ("text/xml".equals(mime)) content = "<pre>" + HtmlUtil.showXmlTags(content) + "</pre>";
    ResponseWriter w = context.getResponseWriter() ;
    w.write("<table width='90%' cellspacing='5' cellpading='3'>") ;
    w.  write("<tr>");
    w.    write("<td>") ;
    w.      write(content) ;
    w.    write("</td>") ;
    w.  write("</tr>") ;
    w.  write("<tr");
    w.    write("<td align='center'>") ;
    uiDisplayer.appendLink(w, "Back", backParams, "") ;
    w.    write("</td>") ;
    w.  write("</tr>") ;
    w.write("</table>");
  }
}