/**
 **************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.portlets.content.jcr.component;

import javax.jcr.Item;
import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.jcr.core.ItemLocation;

/**
 * @author <a href="tuan08@users.sourceforge.net">Tuan Nguyen</a>
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: JCRExplorer.java,v 1.1 2004/11/02 20:02:52 geaz Exp $
 */

public class JCRExplorer extends UIExoCommand {
  final static public String CHANGE_NODE = "changeNode";
  final static public String CHANGE_PROPERTY = "changeProperty";
  final static public String SAVE_SESSION = "saveSession";
  final static public String REVERT_SESSION = "revertSession";
  final static public String IMPORT_SESSION = "importSession";
  private Item selectedItem;
  
  public JCRExplorer() {
    setRendererType("JCRExplorerRenderer");
    setId("JCRExplorer");
    addActionListener(ChangeNodeActionListener.class, CHANGE_NODE);
    addActionListener(ChangePropertyActionListener.class, CHANGE_PROPERTY);
    addActionListener(SaveSessionActionListener.class, SAVE_SESSION);
  }
  
  public Item getSelectedItem() {
    return selectedItem;
  }
  
  public void setSelectedItem(Item item) {
    selectedItem = item;
  }
  
  public Item getSelectedNode() {
    return selectedItem;
  }
  
  final public void changeNode(String path) throws Exception {
    selectedItem = selectedItem.getTicket().getNodeByAbsPath(path);
  }
  
  final public void changeProperty(String path) throws Exception {
    ItemLocation location = new ItemLocation(path);
    selectedItem = selectedItem.getTicket().getNodeByAbsPath(location.getParentPath()).getProperty(location.getName());
  }
  
  private void removeNode(String uri) throws Exception {
    //update the select node
  }
  
  public void updateCache(String uri) throws Exception {
  }
  
  static public class ChangeNodeActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      JCRExplorer uiExplorer = (JCRExplorer)event.getComponent();
      String uri = event.getParameter("uri");
      uiExplorer.changeNode(uri);
    }
  }
  
  
  static public class ChangePropertyActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      JCRExplorer uiExplorer = (JCRExplorer)event.getComponent();
      String uri = event.getParameter("uri");
      uiExplorer.changeProperty(uri);
    }
  }
  
  static public class SaveSessionActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      JCRExplorer uiExplorer = (JCRExplorer)event.getComponent();
      uiExplorer.getSelectedItem().getTicket().save();
      System.out.println(">>>> Session saved <<<<<<<<<");
    }
  }
}
