/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.servlets.content;

import java.io.IOException;
import java.io.File ;
import java.io.FileInputStream ;
import javax.servlet.*;
import javax.servlet.http.*;
import org.exoplatform.commons.utils.MimeTypeUtil;

/**
 * Created by The eXo Platform SARL        .
 * Sun, Dec 28, 2003 @ 14:57 
 * @author: Tuan Nguyen
 * @version: $Id: FileContentServlet.java,v 1.3 2004/06/23 03:19:01 tuan08 Exp $
 * @email: tuan08@yahoo.com
 */
public class FileContentServlet extends HttpServlet {

  public void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    ServletOutputStream os = response.getOutputStream() ;
    try {
      //long headerValue = request.getDateHeader("If-Modified-Since");
      //System.out.println("if modified since....... " + headerValue);
      String path = request.getParameter("path") ;
      if(path == null) {
        response.setContentType("text/plain");
        os.println("path: " + path + " is not found") ;
      } else {
        File file = new File(path) ;
        String mimeType = MimeTypeUtil.getMimeType(file.getName()) ;
        //System.out.println("mime type = " + mimeType);
        response.setContentType(mimeType);
        FileInputStream is = new FileInputStream(file) ;
        byte[] buf = new byte[is.available()] ;
        //System.out.println("buf length = " + buf.length);
        //response.setHeader("Cache-Control", "public, private max-age=600, s-maxage=120");
        //System.out.println("write image content");
        is.read(buf);
        os.write(buf) ;
        is.close() ;
      }
    } catch (Exception ex) {
      os.println("Error: " + ex.getMessage()) ;
      ex.printStackTrace() ;
    }
  }
}
