/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.user.component;

import java.util.ArrayList;
import java.util.List;
import org.exoplatform.faces.core.component.UISelectBox;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.component.model.*;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
/**
 * Sat, Jan 03, 2004 @ 11:16 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UISearchUserForm.java,v 1.6 2004/10/22 14:23:30 tuan08 Exp $
 */
public class UISearchUserForm extends UISimpleForm {

  private static List GENDERS ;

  public static final String SEARCH_USER = "searchUser";
  public static final String REFRESH = "refresh";

  static {
    GENDERS = new ArrayList(10) ;
    GENDERS.add(new SelectItem("All", ""))  ;
    GENDERS.add(new SelectItem("male", "male"))  ;
    GENDERS.add(new SelectItem("female", "female"))  ;
  }

  private UIStringInput userName_ ;
  private UISelectBox   genderInput_ ;

  public UISearchUserForm() {
    super("searchForm", "post", null) ;
    setId("UISearchUserForm");
    userName_ = new UIStringInput("userName", "") ;
    genderInput_ = new UISelectBox("gender","" , GENDERS)  ;
    add(new Row().
        add(new LabelCell("#{UISearchUserForm.label.user-name}")).
        add(new ComponentCell(this, userName_))) ;
    add(new Row().
        add(new LabelCell("#{UISearchUserForm.label.gender}")).
        add(new ComponentCell(this, genderInput_))) ;
    add(new Row().
        add(new ListComponentCell().
            add(new FormButton("#{UISearchUserForm.button.refresh}", REFRESH)).
            add(new FormButton("#{UISearchUserForm.button.search}", SEARCH_USER)).            
            addColspan("2").addAlign("center"))) ;
   
    addActionListener(SearchUserActionListener.class, SEARCH_USER) ;  
    addActionListener(RefreshActionListener.class, REFRESH );
  }

  static public class SearchUserActionListener extends ExoActionListener  {
    public void execute(ExoActionEvent event) throws Exception {
      UISearchUserForm uiForm = (UISearchUserForm) event.getComponent() ;
    	UIListUser uiListUser = (UIListUser) uiForm.getParent() ;
    	String userName = event.getParameter("userName") ;
    	String gender = event.getParameter("gender") ;
    	uiListUser.search(userName, gender) ;
    }
  }

  static public class RefreshActionListener extends ExoActionListener  {
    public void execute(ExoActionEvent event) throws Exception {
      UISearchUserForm uiForm = (UISearchUserForm) event.getComponent() ;
    	UIListUser uiListUser = (UIListUser) uiForm.getParent() ;
      uiForm.genderInput_.setValue("") ;
      uiForm.userName_.setValue("") ;
    	uiListUser.refresh() ;
    }
  }
}