/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.user.renderer.html;

import java.io.IOException;
import java.util.Map;
import java.util.ResourceBundle;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import org.exoplatform.faces.core.renderer.html.HtmlBasicRenderer;
import org.exoplatform.portlets.user.component.UIUserProfile;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UserProfileFormRenderer.java,v 1.8 2004/08/28 18:59:22 tuan08 Exp $
 */
public class UserProfileFormRenderer extends  HtmlBasicRenderer {
  final public static String PICTURE_ICON = "<img class='picture-icon' src='/skin/blank.gif'/>";
  
  final public void encodeBegin( FacesContext context, UIComponent component ) throws IOException {
    ResourceBundle res = getApplicationResourceBundle(context.getExternalContext()) ;
    ResponseWriter w = context.getResponseWriter() ;
    UIUserProfile uiProfile = (UIUserProfile) component ;
    Map userInfo = uiProfile.getUserInfoMap() ;
    String baseUrl = uiProfile.getBaseURL() ;
    String title = res.getString("UIUserProfile.header.viewing-user-info") ;
    w.write("<form  name='userInfoForm' action='" +baseUrl + "' method='post'>\n") ;
    w.  write("<input type='hidden' name='"+ ACTION +"'  value=''/>\n");
    w.  write("<table class='UIUserProfile'>"); 
    w.    write("<tr class='header'>");
    w.      write("<th colspan='2'>");
    w.        write(title);
    w.      write("</th>");
    w.    write("</tr>");
    w.    write("<tr>");
    w.      write("<td width='50%'>");
    addSection(w, res, userInfo, "UIUserProfile.header.personal-info", UIUserProfile.PERSONAL_INFO_KEYS) ;
    addSection(w, res, userInfo, "UIUserProfile.header.user-home-info", UIUserProfile.HOME_INFO_KEYS) ;
    addSection(w, res, userInfo, "UIUserProfile.header.user-businese-info", UIUserProfile.BUSINESE_INFO_KEYS) ;
    w.      write("</td>");
    w.      write("<td class='image-section'>");
    w.      write(PICTURE_ICON);
    w.      write("</td>");
    w.    write("</tr>");

    w.    write("<tr>");
    w.      write("<td colspan='2' class='footer'>");
    w.        write(getScript());
    w.        write("<a href=\"javascript:submitUserProfileForm('"+ SAVE_ACTION+"')\";>") ;
    w.          write(res.getString("UIUserProfile.button.save"));
    w.        write("</a> ") ;
    w.        write("<a href=\"javascript:submitUserProfileForm('"+ CANCEL_ACTION+"')\";>") ;
    w.          write(res.getString("UIUserProfile.button.back"));
    w.        write("</a>") ;
    w.      write("</td>");
    w.    write("</tr>");
    w.  write("</table>");
    w.write("</form>");
  }

  private void addSection(ResponseWriter w, ResourceBundle res, Map userInfo,
                          String titleKey, String[] keys) throws IOException {
    w.write("<table class='section'>");
    w.  write("<tr>");
    w.    write("<th colspan='2'>"); w.write(res.getString(titleKey));w.write("</th>") ;
    w.  write("</tr>") ;
    for (int i = 0 ; i < keys.length; i++) {
      String value = ft_.format((String) userInfo.get(keys[i])) ;
      if (i % 2 == 0) {  
         w.write("<tr class='even'>");
      } else {
         w.write("<tr class='odd'>");
      }
      w.  write("<td>"); w.write(res.getString(keys[i])) ; w.write("</td>");
      w.  write("<td>"); w.write("<input name='"+keys[i]+"' value='"+value+"'"); w.write("</td>");
      w.write("</tr>");
    }
    w.write("</table>") ;
  }

  public String getScript() {
    String script = 
      "<script type='text/javascript'>\n" +
      "  //ie bug  you cannot have more than one button tag\n" +
      "  function submitUserProfileForm(action) {\n" +
      "    document.userInfoForm.elements['"+ACTION+"'].value = action ;\n" +
      "    document.userInfoForm.submit();\n" +
      "  }\n" +
      "</script>\n" ;
    return script ;
  }
}