/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.user.renderer.html;

import java.util.* ;
import java.util.ResourceBundle  ;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import org.exoplatform.commons.utils.Formater;
import org.exoplatform.faces.core.component.model.*;
import org.exoplatform.faces.core.renderer.html.HtmlBasicRenderer;
import org.exoplatform.portlets.user.component.UIUserProfile;
import java.io.IOException;

/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UserProfileRenderer.java,v 1.8 2004/07/22 17:08:18 tuan08 Exp $
 */
public class UserProfileRenderer extends  HtmlBasicRenderer {

  final public static String PICTURE_ICON = "<img class='picture-icon' src='/skin/blank.gif'/>";

  private static Parameter[] backParams = { new Parameter(ACTION , BACK_ACTION)} ;
  private static Parameter[] editParams = { new Parameter(ACTION , EDIT_ACTION)} ;
  static private Formater ft_ = Formater.getFormater(null) ;
   
  final public void encodeBegin( FacesContext context, UIComponent component ) throws IOException {
    ResourceBundle res = getApplicationResourceBundle(context.getExternalContext()) ;
    ResponseWriter w = context.getResponseWriter() ;
    UIUserProfile uiUserProfile = (UIUserProfile) component ;
    Map userInfo = uiUserProfile.getUserInfoMap() ;
    String title = res.getString("UIUserProfile.header.viewing-user-info") ;
    w.write("<table class='UIUserProfile'>");
    w.  write("<tr>");
    w.    write("<th colspan='2' class='header'>");
    w.      write(title);
    w.    write("</th>");
    w.  write("</tr>");
    w.  write("<tr>");
    w.    write("<td width='50%'>");
    addSection(w, res, userInfo, "UIUserProfile.header.personal-info", UIUserProfile.PERSONAL_INFO_KEYS) ;
    addSection(w, res, userInfo, "UIUserProfile.header.user-home-info", UIUserProfile.HOME_INFO_KEYS) ;
    addSection(w, res, userInfo, "UIUserProfile.header.user-businese-info", UIUserProfile.BUSINESE_INFO_KEYS) ;
    w.    write("</td>");
    w.    write("<td class='image-section'>");
    w.      write(PICTURE_ICON);
    w.    write("</td>");
    w.  write("</tr>");
    w.write("<tr>");
    w.  write("<td class='footer' colspan='2'>");
    if (uiUserProfile.isEditable()) {
      uiUserProfile.appendLink(w, res.getString("UIUserProfile.button.edit"), editParams, "") ;
    } 
    if(uiUserProfile.showBackButton()) {
        uiUserProfile.appendLink(w, res.getString("UIUserProfile.button.back"),backParams, "") ;
    }
    w.  write("</td>");
    w.write("</tr>");
    w.write("</table>");
  }

  private void addSection(ResponseWriter w, ResourceBundle res, Map userInfo,
                          String titleKey, String[] keys) throws IOException {
    w.write("<table class='section'>");
    w.  write("<tr>");
    w.    write("<th colspan='2'>"); w.write(res.getString(titleKey)); w.write("</th>") ;
    w.  write("</tr>") ;
    for (int i = 0 ; i < keys.length; i++) {
      if (i % 2 == 0) {  
        w.write("<tr class='even'>");
      } else {
        w.write("<tr class='odd'>");
      }
      w.  write("<td>");w.write(res.getString(keys[i])) ;w.write("</td>");
      w.  write("<td>");w.write(ft_.format((String) userInfo.get(keys[i])));w.write("</td>");
      w.write("</tr>");
    }
    w.write("</table>") ;
  }
}