/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.portlets.weather.component;

import java.util.List;
import org.exoplatform.faces.core.component.UIInput;
import org.exoplatform.portal.ExoPortalInfo;


/**

 * 

 */

public class UISelectList extends UIInput {

	protected String value_ ;
	private List options_ ;

	public UISelectList(String name, String value, List options) {
		super();
		name_ = name ;
		value_ = value;
		options_ = options ;
	  	setId(name) ;
	  	setRendererType("SelectListRenderer") ;
		String clientRenderer = ExoPortalInfo.getCurrentInstance().getClientInfo().getRenderer();
		if (clientRenderer.equals("default")) {
			setRendererType("SelectListRenderer");
		} else if (clientRenderer.equals("xhtmlmp")) {
			setRendererType("XHTMLMPSelectListRenderer");
		}
	}

	final public String getValue() { return value_ ; }

	final public UISelectList setValue(String s) { 
		value_ = s ; 
		return this ;
	}

	final public List getOptions() { return options_ ; }

	final public UISelectList setOptions(List options) { 
		options_ = options ; 
		return this ;
	}
}

