/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.cache.impl;

import java.io.Serializable;
import java.util.* ;
import java.lang.ref.SoftReference;
import org.exoplatform.services.cache.ExoCache;
/**
 * Created by The eXo Platform SARL
 * Author : Tuan Nguyen
 *          tuan08@users.sourceforge.net
 * Sat, Sep 13, 2003 @  
 * Time: 1:12:22 PM
 */
public class SimpleExoCache  extends LinkedHashMap implements ExoCache {
	private static int DEFAULT_MAX_SIZE =  100 ;
	private int maxSize_ ;
	
	 public SimpleExoCache() {
  	maxSize_  = DEFAULT_MAX_SIZE ;
  }
	
  public SimpleExoCache(int maxSize) {
  	maxSize_  = maxSize ;
  }
  
  public int  getMaxSize() { return maxSize_ ; }
  public void setMaxSize(int max) { maxSize_ = max ; }
  
  public Object get(Serializable name) throws Exception {
  	SoftReference ref = (SoftReference) super.get(name) ;
  	if(ref !=  null)  return ref.get() ;
  	return null ;
  }
  
  public Object remove(Serializable name) throws Exception {
  	SoftReference ref = (SoftReference) super.remove(name) ;
  	if(ref !=  null)  return ref.get() ;
  	return null ;
  }

  synchronized public void put(Serializable name, Object obj) throws Exception {
  	SoftReference ref = new SoftReference(obj) ;
  	super.put(name, ref) ;
  }
  
  protected boolean removeEldestEntry(Map.Entry eldest) {
    return size() > maxSize_ ;
 }
}