package org.exoplatform.services.ldap;

import org.exoplatform.services.exception.ExoServiceException;
import netscape.ldap.*;



/**
 * Created by the eXo platform team
 * User: Daniel Summer
 * Date: 25/5/2004
 *
 * interface abstracted from JSDK
 */
public interface LDAPService {
	
	public void connect(
		java.lang.String host,
		int port)
		throws ExoServiceException;
	public void authenticate(
		java.lang.String dn,
		java.lang.String passwd)
		throws ExoServiceException;
	public void add(LDAPEntry entry) throws ExoServiceException;
	public void delete(java.lang.String DN) throws ExoServiceException;
	public void modify(java.lang.String DN, LDAPModification mod) throws ExoServiceException;
	public void modify(java.lang.String DN, LDAPModification[] mods) throws ExoServiceException;
	public void modify(java.lang.String DN, LDAPModificationSet mods)  throws ExoServiceException;
           
	public LDAPEntry read(java.lang.String DN) throws ExoServiceException;
	public void rename(
		java.lang.String DN,
		java.lang.String newRDN,
		boolean deleteOldRDN) throws ExoServiceException;
	public LDAPSearchResults search(
		java.lang.String base,
		int scope,
		java.lang.String filter,
		java.lang.String[] attrs,
		boolean attrsOnly) throws ExoServiceException;
	public void disconnect()  throws ExoServiceException;


}
