/***************************************************************************
 * Copyright 2001-2004 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
/**
 * Created by The eXo Platform SARL        .
 * Author : Daniel Summer
 *          danny_xcz@users.sourceforge.net
 * Date: 25/5/2004
 * 
 */

package org.exoplatform.services.ldap.impl;

import java.util.Stack;
import org.exoplatform.services.exception.ExoServiceException;
import org.exoplatform.services.ldap.LDAPService;
import org.exoplatform.services.ldap.LDAPServiceContainer;
import org.exoplatform.services.log.LogService;

public class LDAPServiceContainerImpl implements LDAPServiceContainer {
	private LDAPServiceConfig ldapServiceConfig_;
	private LogService logService_;
	private Stack pool = new Stack();
	int min = 1;
	int max = 10;

	public LDAPServiceContainerImpl(LogService lservice) throws Exception {
	  logService_ = lservice;
	  ldapServiceConfig_ = new LDAPServiceConfig();
	  for (int i = 0; i < min; i++) {
	    LDAPService service = new LDAPServiceImpl(logService_);
	    service.connect(ldapServiceConfig_.SERVICES_LDAP_HOST,
	                    ldapServiceConfig_.SERVICES_LDAP_PORT);
	    service.authenticate(ldapServiceConfig_.SERVICES_LDAP_BASEDN,
	                         ldapServiceConfig_.SERVICES_LDAP_PASSWD);
	    pool.push(service);
	  }
	}

	public LDAPService createLDAPService() throws ExoServiceException {
		LDAPService service = null;

		if (pool.size() > 0) {
			service = (LDAPService) pool.pop();
		} else {
			service = new LDAPServiceImpl(logService_);
			System.out.print("Begin authentication.");
			service.connect(ldapServiceConfig_.SERVICES_LDAP_HOST,
				              ldapServiceConfig_.SERVICES_LDAP_PORT);
			service.authenticate(ldapServiceConfig_.SERVICES_LDAP_BASEDN,
				                   ldapServiceConfig_.SERVICES_LDAP_PASSWD);

		}
		return service;
	}

	public void closeLDAPService(LDAPService ldapService)
		throws ExoServiceException {
		if ((pool.size() + 1) > max) {
			ldapService.disconnect();
		} else {
			pool.push(ldapService);
		}
	}

}
