/*
 * Copyright 2001-2003 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail. 
 */

package org.exoplatform.services.ldap.impl;




import org.apache.commons.logging.Log;
import org.exoplatform.services.exception.ExoServiceException;
import org.exoplatform.services.ldap.LDAPService;
import org.exoplatform.services.log.LogService;

import netscape.ldap.*;


/**
 * Created y the eXo platform team
 * User: Daniel Summer
 * Date: 25/5/2004
 */
public class LDAPServiceImpl implements LDAPService {
	
	private LDAPConnection conn = new LDAPConnection();
	private Log log_;

	public LDAPServiceImpl(LogService logService) {
		
		this.log_ = logService.getLog("org.exoplatform.services.ldap");

	}

	public void connect(
	java.lang.String host,
	int port)
	throws ExoServiceException {
		try {
			conn.connect(host, port);
		} catch (LDAPException e) {
			throw new ExoServiceException(e);
		}
	}

	public void authenticate(
	java.lang.String dn,
	java.lang.String passwd)
	throws ExoServiceException {
		try {
			conn.authenticate(dn, passwd);
		} catch (LDAPException e) {
			throw new ExoServiceException(e);
		}
	}


	public void add(LDAPEntry entry) throws ExoServiceException {
		
		try {
			conn.add(entry);
		} catch (LDAPException e) {
			throw new ExoServiceException(e);
		}
	}


	public void delete(String DN) throws ExoServiceException {
		
		try {
			conn.delete(DN);
		} catch (LDAPException e) {
			throw new ExoServiceException(e);
		}

	}


	public void modify(String DN, LDAPModification mod)
		throws ExoServiceException {
		
		try {
			conn.modify(DN, mod);
		} catch (LDAPException e) {
			throw new ExoServiceException(e);
		}
	}


	public LDAPEntry read(String DN) throws ExoServiceException {
		
		try {
			return conn.read(DN);
		} catch (LDAPException e) {
			throw new ExoServiceException(e);
		}
	}


	public void rename(String DN, String newRDN, boolean deleteOldRDN)
		throws ExoServiceException {
		
		try {
			conn.rename(DN, newRDN, deleteOldRDN);
		} catch (LDAPException e) {
			throw new ExoServiceException(e);
		}
	}


	public LDAPSearchResults search(
		String base,
		int scope,
		String filter,
		String[] attrs,
		boolean attrsOnly)
		throws ExoServiceException {
		
		try {
			return conn.search(base, scope, filter, attrs, attrsOnly);
		} catch (LDAPException e) {
			throw new ExoServiceException(e);
		}
	}
	
	public void disconnect()
		throws ExoServiceException {
		
		try {
			conn.disconnect();
		} catch (LDAPException e) {
			throw new ExoServiceException(e);
		}
	}



	public void modify(String DN, LDAPModification[] mods)
		throws ExoServiceException {
			try {
				conn.modify(DN, mods);
			} catch (LDAPException e) {
				throw new ExoServiceException(e);
			}

	}
	
	public void modify(String DN, LDAPModificationSet mods)
		throws ExoServiceException {
			try {
				conn.modify(DN, mods);
			} catch (LDAPException e) {
				throw new ExoServiceException(e);
			}

	}

}
