/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.organization.ldap;

import java.util.List; 

import org.exoplatform.commons.utils.ExoProperties;
import org.exoplatform.container.configuration.*;

import org.exoplatform.services.organization.*;
import org.picocontainer.Startable;
/**
 * Jul 20, 2004 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: OrganizationServiceListenerImpl.java,v 1.5 2004/11/03 11:37:21 danny_xcz Exp $
 */
public class OrganizationServiceListenerImpl extends OrganizationServiceListener 
  implements Startable {
  
  private ServiceConfiguration sconfiguration_ ;
  
  public OrganizationServiceListenerImpl(OrganizationService orgService,
                                         ConfigurationManager cService) throws Exception {
    /*                                     	
    Query q = new Query() ;
    q.setFrom(0) ;
    q.setTo(5) ;
    List users = orgService.findUsers(q);
    if(users.size() > 0) return ; //Not new database 
    orgService.addListener(this);
    sconfiguration_ = cService.getServiceConfiguration(getClass()) ;
    */
  }
  
  public void start() { } 
  public void stop() {} 
  
  public void inititalize(OrganizationService service) {
  	/*
  	if(sconfiguration_ == null) return ;
  	try {
  		InitParam param = sconfiguration_.getInitParam("group") ;
  		if(param != null) createGroups(service, param.getValues()) ;
      param = sconfiguration_.getInitParam("role") ;
      param = sconfiguration_.getInitParam("membership") ;
      if(param != null) createMembershipTypes(service, param.getValues()) ;
      param = sconfiguration_.getInitParam("users") ;
      if(param != null) createUsers(service, param.getValues(), true) ;
  	} catch (Exception ex) {
  		ex.printStackTrace() ; 
  	}
  	*/
  }
  
  private void createGroups(OrganizationService orgService, List groups) throws Exception {
    ExoProperties props = new ExoProperties() ;
    for(int i = 0 ; i < groups.size() ; i++) {
      props.clear() ;
      props.addPropertiesFromText((String) groups.get(i)) ;
      Group group = orgService.createGroupInstance();
      group.setGroupName(props.getProperty("name"));
      orgService.createGroup(group); 
    }
  }
  
  private void createMembershipTypes(OrganizationService orgService, List types) throws Exception {
    ExoProperties props = new ExoProperties() ;
    for(int i = 0 ; i < types.size() ; i++) {
      props.clear() ;
      props.addPropertiesFromText((String) types.get(i)) ;
      MembershipType type = orgService.createMembershipTypeInstance();
      type.setName(props.getProperty("membership-type")) ; 
      type.setDescription(props.getProperty("description")) ;
      orgService.createMembershipType(type) ;
    }
  }
  
  private void createUsers(OrganizationService service, List users, boolean admin) throws Exception {
    ExoProperties props = new ExoProperties() ;
  	for(int i = 0 ; i < users.size() ; i++) {
      props.clear() ;
  		props.addPropertiesFromText((String) users.get(i)) ;
  		User user = service.createUserInstance() ;
  		user.setUserName(props.getProperty("user-name")) ;
  		user.setPassword(props.getProperty("password")) ;
  		user.setFirstName(props.getProperty("first-name")) ;
  		user.setLastName(props.getProperty("last-name")) ;
  		user.setEmail(props.getProperty("email")) ;
  		service.createUser(user);
  	}
  }
}