 /***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.portal.impl;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.ResourceBundle;
import org.exoplatform.commons.utils.MapResourceBundle;
import org.exoplatform.services.portletcontainer.bundle.ResourceBundleDelegate;
import org.exoplatform.services.resources.ResourceBundleService;


/**
 * @author Benjamin Mestrallet
 * benjamin.mestrallet@exoplatform.com
 */
public class ResourceBundleDelegateImpl implements ResourceBundleDelegate {
  
  private static final String CUSTOM_PROPERTIES_PATH = "locale.custom.custom";
  private static final String PORTAL_PROPERTIES_PATH = "locale.portal.portal";
  
  private ResourceBundleService resourceBundleService;
  
  public ResourceBundleDelegateImpl(ResourceBundleService resourceBundleService) {    
    this.resourceBundleService = resourceBundleService;
  }
  
  public MapResourceBundle lookupBundle(String portletBundleName, Locale locale){    
    MapResourceBundle outputBundled = new MapResourceBundle(locale);    
    List list = new ArrayList();
    list.add(PORTAL_PROPERTIES_PATH);
    list.add(portletBundleName);
    list.add(CUSTOM_PROPERTIES_PATH);        
    for (Iterator iter = list.iterator(); iter.hasNext();) {
      String bundleName = (String) iter.next();      
      ResourceBundle rB = resourceBundleService.getResourceBundle(bundleName, locale);      
      outputBundled.merge(rB);      
    }        
    outputBundled.resolveDependencies();
    return outputBundled;
  }

}
