/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.xml.transform;

import javax.xml.transform.Source;
import javax.xml.transform.Result;
import java.util.Properties;
import javax.xml.transform.URIResolver;
import javax.xml.transform.TransformerException;

/**
 * Created by The eXo Platform SARL        .
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: Transformer.java,v 1.4 2004/03/15 09:36:32 geaz Exp $
 */

public interface Transformer {

//    void initTransformRules(TransformRules rules)  throws TransformerException;

    void transform(Source source, Result result) throws TransformerException;

    Object getParameter(String param);

    void setParameter(String name, Object value);

    void clearParameters();

    String getOutputProperty(String prop);

    void setOutputProperty(String name, String value);

    void setOutputProperties(Properties props);

    Properties getOutputProperties();

    URIResolver getURIResolver();

    void setURIResolver(URIResolver resolver);

    /** @link dependency */
    /*# TransformRules lnkTransformRules; */
}
