/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.xml.resolving.impl.simple;

import java.io.IOException;
import java.io.InputStream;

import org.xml.sax.EntityResolver;
import org.xml.sax.InputSource;

/**
 * Created by The eXo Platform SARL        .
 *
 * Entity Resolver for SimpleDir resolving service
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: SimpleResolver.java,v 1.4 2004/10/07 18:27:07 benjmestrallet Exp $
 */

public class SimpleResolver implements EntityResolver 
{
   private String localPath;
   
   public SimpleResolver(String localPath)
   {
      this.localPath = localPath;
   }

   public InputSource resolveEntity (String publicId, String systemId) throws IOException
   {
      int fileIndex = systemId.lastIndexOf('/');
      if(fileIndex == -1) 
          return null;

      String dtdPath = localPath+systemId.substring(fileIndex);
      if(this.getClass().getResource(dtdPath) == null) {
          System.out.println("SimpleResolver: local copy of '"+dtdPath+" not found in catalog. Trying to load from "+systemId+"..");
          return null;
      }      
      InputSource source = new InputSource(this.getClass().getResourceAsStream(dtdPath)); 
      source.setSystemId(systemId); 
      return source;       
   }
}

