/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.xml.transform.impl;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.services.xml.transform.Transformer;
import org.exoplatform.services.xml.transform.TransformingService;

/**
 * Created by The eXo Platform SARL        .
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: TransformingServiceImpl.java,v 1.5 2004/07/24 16:39:14 tuan08 Exp $
 */

public class TransformingServiceImpl implements TransformingService 
{

   public TransformingServiceImpl()
   {
   }

   public Transformer getTransformer(Class clazz) throws InstantiationException
   {
       try {
           return (Transformer)clazz.newInstance();
       } catch (IllegalAccessException e) {
           throw new InstantiationException("Illegal Access to Transformer class.");
       }
   }

   public Transformer getTransformer(String className) throws InstantiationException, ClassNotFoundException
   {   
       try {
           return (Transformer)Class.forName(className).newInstance();
       } catch (IllegalAccessException e) {
           throw new InstantiationException("Illegal Access to Transformer class.");
       }

   }

}
