/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.xml.transform.impl.trax;

import java.util.Properties;
import javax.xml.transform.ErrorListener;
import javax.xml.transform.URIResolver;
import javax.xml.transform.Source;
import javax.xml.transform.Result;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerConfigurationException;
import org.exoplatform.services.xml.transform.trax.TraxTransformer;

//import org.exoplatform.services.xml.transform.TransformRules;

/**
 * Created by The eXo Platform SARL        .
 *
 * Wrapper for Trax Transformer 
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: TraxTransformerWrapper.java,v 1.6 2004/06/12 08:08:03 geaz Exp $
 */

public class TraxTransformerWrapper extends Transformer implements TraxTransformer {

    protected Transformer transformer;
    protected TransformerFactory tFactory;

    public TraxTransformerWrapper() throws TransformerException, TransformerConfigurationException
    {
       tFactory = TransformerFactory.newInstance();
       transformer = tFactory.newTransformer();
    }

    public void initStyle(Source xslStyle) throws TransformerException {
       //System.out.println("STYLE-------"+xslStyle.getSystemId());
       if(xslStyle == null)
          throw new TransformerException("TraxTransformerWrapper.initStyle() failed: Style is NULL!");
       transformer = tFactory.newTransformer(xslStyle);
    }

    public void transform(Source source, Result result) throws TransformerException
    {

        try {
           transformer.transform(source, result);
        } catch (Exception e) {
           throw new TransformerException("TraxTransformerWrapper.transform() failed!", e);
        }
    }

    public Object getParameter(String param)
    {
        return transformer.getParameter(param);
    }

    public void setParameter(String name, Object value)
    {
        transformer.setParameter(name, value);
    }

    public void clearParameters()
    {
        transformer.clearParameters();
    }

    public String getOutputProperty(String prop)
    {
        return transformer.getOutputProperty(prop);
    }

    public void setOutputProperty(String name, String value)
    {
        transformer.setOutputProperty(name, value);
    }

    public void setOutputProperties(Properties props)
    {
        transformer.setOutputProperties(props);
    }

    public Properties getOutputProperties()
    {
        return transformer.getOutputProperties();
    }

    public URIResolver getURIResolver()
    {
        return transformer.getURIResolver();
    }

    public void setURIResolver(URIResolver resolver)
    {
        transformer.setURIResolver(resolver);
    }

    public ErrorListener getErrorListener()
    {
        return transformer.getErrorListener();
    }

    public void setErrorListener(ErrorListener listener)
    {
        transformer.setErrorListener(listener);
    }
}
