/**
 * Copyright 2001-2003 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/
package org.exoplatform.services.xml.transform;

import junit.framework.TestCase;

import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;
import org.exoplatform.container.PortalContainer;
import org.exoplatform.services.xml.resolving.impl.simple.SimpleDirResolvingServiceImpl;
import org.exoplatform.services.xml.transform.impl.html.TidyTransformer;
import org.exoplatform.services.xml.transform.impl.pipe.PipeTransformerImpl;
import org.exoplatform.services.xml.transform.impl.trax.TraxTransformerWrapper;
import org.exoplatform.services.xml.transform.pipe.PipeTransformer;
import org.exoplatform.services.xml.transform.trax.Constants;
import java.io.FileInputStream;
import java.io.FileOutputStream;

/**
 * Created by the Exo Development team.
 */
public class TestPipe extends TestCase {

   public void setUp() throws Exception 
   {
   }

   public void testPipe() throws Exception 
   {
      try {
          PipeTransformer pipe = new PipeTransformerImpl();

          StreamResult res = new StreamResult(new FileOutputStream("tmp/rss-out.pipe"));
          FileInputStream fis = new FileInputStream("tmp/rss-out.html");
          TraxTransformerWrapper ur = new TraxTransformerWrapper();
          String xslUrl = Constants.XSLT_DIR+"/html-url-rewite.xsl";
          ur.initStyle(new StreamSource(Thread.currentThread().
                       getContextClassLoader().getResourceAsStream(xslUrl)));

          pipe.addTransformRule(new TidyTransformer()).
               addTransformRule(ur);
          pipe.transform(new StreamSource(fis), res);

       } catch ( Exception e) {
            e.printStackTrace() ;
            fail( "testPipe() ERROR: "+e.toString());
        }
   }
}
