/**
 * Copyright 2001-2003 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/
package org.exoplatform.services.xml.transform;

import junit.framework.TestCase;

import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;
import org.exoplatform.container.PortalContainer;
import org.exoplatform.services.xml.resolving.impl.simple.SimpleDirResolvingServiceImpl;
import org.exoplatform.services.xml.transform.impl.html.TidyTransformer;
import java.io.FileInputStream;
import java.io.FileOutputStream;

/**
 * Created by the Exo Development team.
 */
public class TestTidy extends TestCase {

  public void setUp() throws Exception {
  }

  public void testTidy() throws Exception {
    try {
      TidyTransformer tt = new TidyTransformer();
      StreamResult res = new StreamResult(new FileOutputStream("tmp/rss-out.out"));
      FileInputStream fis = new FileInputStream("tmp/rss-out.html");
      tt.transform(new StreamSource(fis), res);
      assertNotNull(res);
    } catch (Exception e) {
      fail("testTidy() ERROR: " + e.toString());
    }
  }

  public void testProps() throws Exception {
    try {
//          PortalContainer manager = PortalContainer.getInstance();
//          SimpleDirResolvingServiceImpl service = (SimpleDirResolvingServiceImpl) manager.getService(SimpleDirResolvingServiceImpl.class);
      TidyTransformer tt = new TidyTransformer();
      assertEquals(tt.getOutputProperty("quiet"), "true");
//          assertEquals(tt.getTidyParser().getQuiet(), Boolean.getBoolean(tt.getOutputProperty("quiet")));
      tt.setOutputProperty("quiet", "false");
//          assertEquals(tt.getTidyParser().getQuiet(), Boolean.getBoolean("false"));
      assertEquals(tt.getParameter("quiet"), "false");
      tt.setParameter("quiet", "true");
      assertEquals(tt.getParameter("quiet"), "true");

    } catch (Exception e) {

      fail("testProps() ERROR: " + e.toString());
    }

  }


}
