/**
 * Copyright 2001-2003 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/
package org.exoplatform.services.xml.transform;


import org.exoplatform.container.PortalContainer;
import org.exoplatform.services.xml.resolving.*;
import org.exoplatform.services.xml.resolving.impl.simple.*;
import org.exoplatform.services.xml.transform.impl.trax.TraxTransformerWrapper;
import org.exoplatform.services.xml.transform.trax.Constants;
import org.xml.sax.InputSource;
import junit.framework.TestCase;

import java.io.FileOutputStream;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;
import java.io.FileInputStream;
import java.io.InputStream;


/**
 * Created by the Exo Development team.
 */
public class TestUrlRewrite extends TestCase {

  public static final String HTML_URL_REWRITE_STYLE = Constants.XSLT_DIR + "/html-url-rewite.xsl";

  public void setUp() throws Exception {
  }

  public void testUrlRewrite() throws Exception {
    try {
      TraxTransformerWrapper ur = new TraxTransformerWrapper();
      InputStream iS = Thread.currentThread().getContextClassLoader().
          getResource(HTML_URL_REWRITE_STYLE).openStream();
      ur.initStyle(new StreamSource(iS));

      StreamResult res = new StreamResult(new FileOutputStream("tmp/cocoon.out"));
      FileInputStream fis = new FileInputStream("tmp/cocoon.html");

      ur.setParameter("portlet-url", "exo/faces/public/index.jsp");
      ur.setParameter("href-param", "servlet-url");
      ur.setParameter("href-context", "Cocoon/");
      ur.transform(new StreamSource(fis), res);

      res = new StreamResult(new FileOutputStream("tmp/simple-html.out"));
      fis = new FileInputStream("tmp/simple-html.html");
      ur.transform(new StreamSource(fis), res);

      res = new StreamResult(new FileOutputStream("tmp/web.xml.out"));
      fis = new FileInputStream("tmp/web.xml");
      ur.transform(new StreamSource(fis), res);

    } catch (Exception e) {
      e.printStackTrace();
      fail("testUrlRewrite() ERROR: " + e.toString());
    }
  }


}
