/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.test.portal;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * May 21, 2004
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: FileExplorerPortletUserSuite.java,v 1.1 2004/10/11 23:27:28 tuan08 Exp $
 **/
public class FileExplorerPortletAdminSuite  extends WebUnitSuite {
  
  public FileExplorerPortletAdminSuite(String path) {
    super("FileExplorerAdminSuite", "Go to File Explorer and test the admin actions") ;
    goToPage(path) ;
    addWebUnit(
        new ClickLink("ClickEditorLink", "Try to open the editor").
        setTextLink("Editor").
        setBlockId("file-explorer").
        addValidator(new ExpectFormNameValidator("contentForm"))
    );
    addWebUnit(
        new SubmitFormUnit("PreviewContent", "Preview the content").
        setFormName("contentForm").
        setField("op","preview").
        setField("content","Test create new file").
        setBlockId("file-explorer").
        addValidator(new ExpectLinkWithTextValidator("Back"))
    ) ;
    addWebUnit(
        new ClickLink("GoBackToEditor", "Go back to the editor").
        setTextLink("Back").
        setBlockId("file-explorer").
        addValidator(new ExpectFormNameValidator("contentForm"))
    );
    addWebUnit(
        new SubmitFormUnit("SaveContent", "Save Content with file name empty").
        setFormName("contentForm").
        setField("op","saveContent").
        setField("content","Test create new file").
        setBlockId("file-explorer").
        addValidator(new ExpectTextValidator("You need to enter a name for the file"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("SaveContent", "Save Content with file name empty").
        setFormName("contentForm").
        setField("op","saveContent").
        setField("content","Test create new file").
        setField("localName","newFile.txt").
        setBlockId("file-explorer").
        addValidator(new ExpectTextValidator("Your file has been saved successfully"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("SaveContent", "Save Content with the correct information").
        setFormName("contentForm").
        setField("op","cancel").
        setBlockId("file-explorer").
        addValidator(new ExpectTextValidator("newFile.txt"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("RemoveFile", "Remove the new created file").
        setURL("op=removeNode&uri=/newFile.txt").
        setBlockId("file-explorer").
        addValidator(new ExpectTextValidator("The resource has been removed successfully"))
    );
  }
}